/* Listing4717.java */

import javax.persistence.*;
import java.util.List;

public class Listing4717
{
  public static void main(String[] args)
  {
    //Erzeugen einer EntityManagerFactory mit Hilfe des symbolischen
    //Namens aus dem Persistenz Descriptor (persistence.xml)
    EntityManagerFactory emf =
      Persistence.createEntityManagerFactory("persistenceExample");

    //Erzeugen eines EntityManagers fr den Zugriff auf
    //die Datenbank
    EntityManager manager = emf.createEntityManager();

    //Beginn einer neuen Transanktion
    EntityTransaction tx = manager.getTransaction();
    tx.begin();

    //Erzeugen einer Anfrage
    Query query = manager.createQuery("select d from Verzeichnis d"); 

    //Ausfhren der Anfrage und ermittel der Ergebnisliste
    List<Verzeichnis> directories = query.getResultList();  
        
    //Ausgabe der Datenstze
    for(Verzeichnis directory : directories) {
      System.out.println(directory.toString());
    }
        
    //Abschluss der Transaktion mit einem Commit
    tx.commit();
        
    //Freigabe der Ressourcen des EntityManagers
    manager.close();

    //Schlieen der EntityManagerFactory und Freigeben der
    //belegten Ressourcen
    emf.close();
  }
}